/***********************************************
 * Large Assignment 3: Tiling
 * Name:    Jamini Sahu
 * E-mail:  jsahu@unm.edu
 * Course:      CS591, Computational Fabrication
 * Submitted:    3/28/2022
 *
 * This program includes the code to draw out a single tiling,
 * adapted from the regular hexagon tiling. The method shape()
 * takes in a number for size to control how big the tile is.
 * Using that, and the geometry of a regular hexagon, the method
 * computes the sizes needed to create a bat adaptation of the 
 * hexagon. It uses an extra circle() method to add some face
 * details. Then, the method tile() arranges that shape into a 
 * tiling.
***********************************************/

import Turtle.*;
Turtle t;


void setup() {

 size(600,600);
 fill(#B2DCF5, 10);
 strokeWeight(1.5);
 t = new Turtle(this);
 frameRate(50);
 background(#8466EA);
 strokeWeight(2.5);
 tile(100);

}

void draw () {}

void tile(float length){
  t.setX(width/3);
  t.setY(height + 200);
  
  for (int i = 0; i < 6; i ++) {
     t.push();
      for (int j = 0; j < 6; j ++) {
      shape(length);
      t.pop();
      t.setHeading(0);
    }
    t.pop();
    t.left(90); 
    t.forward(length * sqrt(3) - length/20);
    t.right(90);
    t.forward(length/2.2);
    t.setHeading(0);
  }
}


void shape(float length){
  
  float side1 = sin(radians(45))/(sin(radians(60))/ length);
  float side2 = sin(radians(75))/(sin(radians(60))/ length);
  float side3 = length / sqrt(2);
  
  println(side1, side2, side3);
  t.forward(side2);
  t.right(90);
  t.forward(side1);
  t.left(120);
  t.forward(side2);
  t.right(150);
  t.forward(side3);
  
  t.push();
  t.penUp();
  t.right(90);
  t.forward(17);
  //t.penDown();
  circle(2, false);
  t.penUp();
  t.left(135);
  t.forward(25);
  circle(10, true);
  t.right(130);
  t.forward(17);
  circle(2, false);
  //t.left(90);
  //t.forward(side1);
  //t.push();
  t.penDown();

  t.pop();
  
  t.left(90);  
  t.forward(side3);
  t.right(150);
  t.forward(side2);
  t.left(120);
  
  t.push();

  t.forward(side1);
  t.right(90);
  t.forward(side2);
  t.right(120);
  t.forward(side1);
  t.left(60);
  t.forward(side3);
  t.right(90);
  t.forward(side3);
  t.left(60);
  t.forward(side1);
  t.right(120);
}

void circle(float r, boolean half) {

  float c = 2 * 3.141592 * r;
  t.penUp();
  println(t.getHeading());
  t.right(90);
  t.forward(r);
  t.penDown();
  int iter;
  if(half)
     iter = 180;
  else
     iter = 360;
  for (int i = 0; i < iter; i++) {
    if(half && (i % 60 == 0) && (i != 0)){
      t.push();
      t.left(90);
      t.drawTurtle();
      t.pop();
    }
    t.right(1);
    t.forward(c/360);
  }
  t.penUp();
  t.right(90);
  t.forward(r);
  t.right(180);
  
}
